Package org.apache.velocity.runtime

# Interface RuntimeServices

All Known Implementing Classes:
  `RuntimeInstance`

public interface RuntimeServices
Interface for internal runtime services that are needed by the various components w/in Velocity. This was taken from the old Runtime singleton, and anything not necessary was removed. Currently implemented by RuntimeInstance.

Version:
  $Id$
Author:
  Geir Magusson Jr.

## Method Summary

Modifier and Type
Method
Description
`void`
`addProperty(String key, Object value)`
Add a property to the configuration.
`boolean`
`addVelocimacro(String name, Node macro, List<Macro.MacroArg> macroArgs, Template definingTemplate)`
Adds a new Velocimacro.
`void`
`clearProperty(String key)`
Clear the values pertaining to a particular property.
`Parser`
`createNewParser()`
Create a new parser instance.
`boolean`
`evaluate(Context context, Writer writer, String logTag, Reader reader)`
Renders the input reader using the context into the output writer.
`boolean`
`evaluate(Context context, Writer out, String logTag, String instring)`
Renders the input string using the context into the output writer.
`Object`
`getApplicationAttribute(Object key)`
Return the specified application attribute.
`EventCartridge`
`getApplicationEventCartridge()`
Returns the event handlers for the application.
`boolean`
`getBoolean(String key, boolean def)`
Boolean property accessor method to hide the configuration implementation.
`ExtProperties`
`getConfiguration()`
Return the velocity runtime configuration object.
`ContentResource`
`getContent(String name)`
Returns a static content resource from the resource manager.
`ContentResource`
`getContent(String name, String encoding)`
Returns a static content resource from the resource manager.
`Directive`
`getDirective(String name)`
Retrieve a previously instantiated directive.
`int`
`getInt(String key)`
Int property accessor method to hide the configuration implementation.
`int`
`getInt(String key, int defaultValue)`
Int property accessor method to hide the configuration implementation.
`String`
`getLoaderNameForResource(String resourceName)`
Determines is a template exists, and returns name of the loader that provides it.
`org.slf4j.Logger`
`getLog()`
Returns the configured logger.
`org.slf4j.Logger`
`getLog(String childNamespace)`
Get a logger for the specified child namespace.
`LogContext`
`getLogContext()`
Get the LogContext object used to tack locations in templates.
`ParserConfiguration`
`getParserConfiguration()`
Get the replacement characters configured for this runtime service's parser
`Object`
`getProperty(String key)`
Allows an external caller to get a property.
`RuntimeConstants.SpaceGobbling`
`getSpaceGobbling()`
get space gobbling mode
`String`
`getString(String key)`
String property accessor method to hide the configuration implementation
`String`
`getString(String key, String defaultValue)`
String property accessor method with default to hide the configuration implementation.
`Template`
`getTemplate(String name)`
Returns a `Template` from the resource manager.
`Template`
`getTemplate(String name, String encoding)`
Returns a `Template` from the resource manager
`Uberspect`
`getUberspect()`
Returns the configured class introspection/reflection implementation.
`Directive`
`getVelocimacro(String vmName, Template renderingTemplate, Template template)`
Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.
`void`
`init()`
This is the primary initialization method in the Velocity Runtime.
`void`
`init(String configurationFile)`
Initialize the Velocity Runtime with the name of ExtProperties object.
`void`
`init(Properties p)`
Initialize the Velocity Runtime with a Properties object.
`boolean`
`invokeVelocimacro(String vmName, String logTag, String[] params, Context context, Writer writer)`
Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
`boolean`
`isHyphenAllowedInIdentifiers()`
Get whether hyphens are allowed in identifiers
`boolean`
`isInitialized()`
Returns true if the RuntimeInstance has been successfully initialized.
`boolean`
`isScopeControlEnabled(String scopeName)`
Get whether to provide a scope control object for this scope
`boolean`
`isVelocimacro(String vmName, Template template)`
Checks to see if a VM exists
`SimpleNode`
`parse(Reader reader, Template template)`
Parse the input and return the root of AST node structure.
`Object`
`setApplicationAttribute(Object key, Object value)`
Set the specified application attribute.
`void`
`setConfiguration(ExtProperties configuration)`
Allow an external system to set an ExtProperties object to use.
`void`
`setProperty(String key, Object value)`
Allows an external system to set a property in the Velocity Runtime.
`boolean`
`useStringInterning()`
Check whether the engine uses string interning

## Method Details

### init

void init()
This is the primary initialization method in the Velocity Runtime. The systems that are setup/initialized here are as follows:

- Logging System
- ResourceManager
- Parser Pool
- Global Cache
- Static Content Include System
- Velocimacro System

### setProperty

void setProperty(String key, Object value)
Allows an external system to set a property in the Velocity Runtime.

Parameters:
  `key` - property key
  `value` - property value

### setConfiguration

void setConfiguration(ExtProperties configuration)
Allow an external system to set an ExtProperties object to use.

Parameters:
  `configuration` -
Since:
  2.0

### addProperty

void addProperty(String key, Object value)
Add a property to the configuration. If it already exists then the value stated here will be added to the configuration entry. For example, if resource.loader = file is already present in the configuration and you addProperty("resource.loader", "classpath") Then you will end up with a Vector like the following: ["file", "classpath"]

Parameters:
  `key` -
  `value` -

### clearProperty

void clearProperty(String key)
Clear the values pertaining to a particular property.

Parameters:
  `key` - of property to clear

### getProperty

Object getProperty(String key)
Allows an external caller to get a property. The calling routine is required to know the type, as this routine will return an Object, as that is what properties can be.

Parameters:
  `key` - property to return
Returns:
  The value.

### init

void init(Properties p)
Initialize the Velocity Runtime with a Properties object.

Parameters:
  `p` -

### init

void init(String configurationFile)
Initialize the Velocity Runtime with the name of ExtProperties object.

Parameters:
  `configurationFile` -

### parse

SimpleNode parse(Reader reader, Template template) throws ParseException
Parse the input and return the root of AST node structure.
In the event that it runs out of parsers in the pool, it will create and let them be GC'd dynamically, logging that it has to do that. This is considered an exceptional condition. It is expected that the user will set the PARSER_POOL_SIZE property appropriately for their application. We will revisit this.

Parameters:
  `reader` - inputstream retrieved by a resource loader
  `template` - template being parsed
Returns:
  The AST representing the template.
Throws:
  `ParseException`

### evaluate

boolean evaluate(Context context, Writer out, String logTag, String instring)
Renders the input string using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

Parameters:
  `context` - context to use in rendering input string
  `out` - Writer in which to render the output
  `logTag` - string to be used as the template name for log messages in case of error
  `instring` - input string containing the VTL to be rendered
Returns:
  true if successful, false otherwise. If false, see Velocity runtime log
Throws:
  `ParseErrorException` - The template could not be parsed.
  `MethodInvocationException` - A method on a context object could not be invoked.
  `ResourceNotFoundException` - A referenced resource could not be loaded.
Since:
  Velocity 1.6

### evaluate

boolean evaluate(Context context, Writer writer, String logTag, Reader reader)
Renders the input reader using the context into the output writer. To be used when a template is dynamically constructed, or want to use Velocity as a token replacer.

Parameters:
  `context` - context to use in rendering input string
  `writer` - Writer in which to render the output
  `logTag` - string to be used as the template name for log messages in case of error
  `reader` - Reader containing the VTL to be rendered
Returns:
  true if successful, false otherwise. If false, see Velocity runtime log
Throws:
  `ParseErrorException` - The template could not be parsed.
  `MethodInvocationException` - A method on a context object could not be invoked.
  `ResourceNotFoundException` - A referenced resource could not be loaded.
Since:
  Velocity 1.6

### invokeVelocimacro

boolean invokeVelocimacro(String vmName, String logTag, String[] params, Context context, Writer writer)
Invokes a currently registered Velocimacro with the params provided and places the rendered stream into the writer.
Note : currently only accepts args to the VM if they are in the context.

Parameters:
  `vmName` - name of Velocimacro to call
  `logTag` - string to be used for template name in case of error. if null, the vmName will be used
  `params` - keys for args used to invoke Velocimacro, in java format rather than VTL (eg "foo" or "bar" rather than "$foo" or "$bar")
  `context` - Context object containing data/objects used for rendering.
  `writer` - Writer for output stream
Returns:
  true if Velocimacro exists and successfully invoked, false otherwise.
Since:
  1.6

### getTemplate

Template getTemplate(String name) throws ResourceNotFoundException, ParseErrorException
Returns a `Template` from the resource manager. This method assumes that the character encoding of the template is set by the `input.encoding` property. The default is UTF-8.

Parameters:
  `name` - The file name of the desired template.
Returns:
  The template.
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getTemplate

Template getTemplate(String name, String encoding) throws ResourceNotFoundException, ParseErrorException
Returns a `Template` from the resource manager

Parameters:
  `name` - The name of the desired template.
  `encoding` - Character encoding of the template
Returns:
  The template.
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException` - if template cannot be parsed due to syntax (or other) error.

### getContent

ContentResource getContent(String name) throws ResourceNotFoundException, ParseErrorException
Returns a static content resource from the resource manager. Uses the current value if INPUT_ENCODING as the character encoding.

Parameters:
  `name` - Name of content resource to get
Returns:
  parsed ContentResource object ready for use
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException`

### getContent

ContentResource getContent(String name, String encoding) throws ResourceNotFoundException, ParseErrorException
Returns a static content resource from the resource manager.

Parameters:
  `name` - Name of content resource to get
  `encoding` - Character encoding to use
Returns:
  parsed ContentResource object ready for use
Throws:
  `ResourceNotFoundException` - if template not found from any available source.
  `ParseErrorException`

### getLoaderNameForResource

String getLoaderNameForResource(String resourceName)
Determines is a template exists, and returns name of the loader that provides it. This is a slightly less hokey way to support the Velocity.templateExists() utility method, which was broken when per-template encoding was introduced. We can revisit this.

Parameters:
  `resourceName` - Name of template or content resource
Returns:
  class name of loader than can provide it

### getString

String getString(String key, String defaultValue)
String property accessor method with default to hide the configuration implementation.

Parameters:
  `key` - property key
  `defaultValue` - default value to return if key not found in resource manager.
Returns:
  String value of key or default

### getVelocimacro

Directive getVelocimacro(String vmName, Template renderingTemplate, Template template)
Returns the appropriate VelocimacroProxy object if strVMname is a valid current Velocimacro.

Parameters:
  `vmName` - Name of velocimacro requested
  `renderingTemplate` - Template we are currently rendering. This information is needed when VM_PERM_ALLOW_INLINE_REPLACE_GLOBAL setting is true and template contains a macro with the same name as the global macro library.
  `template` - current template
Returns:
  VelocimacroProxy

### addVelocimacro

boolean addVelocimacro(String name, Node macro, List<Macro.MacroArg> macroArgs, Template definingTemplate)
Adds a new Velocimacro. Usually called by Macro only while parsing.

Parameters:
  `name` - Name of velocimacro
  `macro` - root AST node of the parsed macro
  `macroArgs` - Array of macro arguments, containing the #macro() arguments and default values. the 0th is the name.
  `definingTemplate` - template containing macro definition
Returns:
  boolean True if added, false if rejected for some reason (either parameters or permission settings)

### isVelocimacro

boolean isVelocimacro(String vmName, Template template)
Checks to see if a VM exists

Parameters:
  `vmName` - Name of velocimacro
  `template` - Template "namespace"
Returns:
  boolean True if VM by that name exists, false if not

### getString

String getString(String key)
String property accessor method to hide the configuration implementation

Parameters:
  `key` - property key
Returns:
  value of key or null

### getInt

int getInt(String key)
Int property accessor method to hide the configuration implementation.

Parameters:
  `key` - property key
Returns:
  int value

### getInt

int getInt(String key, int defaultValue)
Int property accessor method to hide the configuration implementation.

Parameters:
  `key` - property key
  `defaultValue` - default value
Returns:
  int value

### getBoolean

boolean getBoolean(String key, boolean def)
Boolean property accessor method to hide the configuration implementation.

Parameters:
  `key` - property key
  `def` - default default value if property not found
Returns:
  boolean value of key or default value

### getConfiguration

ExtProperties getConfiguration()
Return the velocity runtime configuration object.

Returns:
  ExtProperties configuration object which houses the velocity runtime properties.

### getApplicationAttribute

Object getApplicationAttribute(Object key)
Return the specified application attribute.

Parameters:
  `key` - The name of the attribute to retrieve.
Returns:
  The value of the attribute.

### setApplicationAttribute

Object setApplicationAttribute(Object key, Object value)
Set the specified application attribute.

Parameters:
  `key` - The name of the attribute to set.
  `value` - The attribute value to set.
Returns:
  the displaced attribute value

### getUberspect

Uberspect getUberspect()
Returns the configured class introspection/reflection implementation.

Returns:
  The current Uberspect object.

### getLog

org.slf4j.Logger getLog()
Returns the configured logger.

Returns:
  A Logger object.

### getLog

org.slf4j.Logger getLog(String childNamespace)
Get a logger for the specified child namespace. If a logger was configured using the runtime.log.instance configuration property, returns this instance. Otherwise, uses SLF4J LoggerFactory on baseNamespace + childNamespace.

Parameters:
  `childNamespace` -
Returns:
  child name space logger

### getLogContext

LogContext getLogContext()
Get the LogContext object used to tack locations in templates.

Returns:
  LogContext object
Since:
  2.2

### getApplicationEventCartridge

EventCartridge getApplicationEventCartridge()
Returns the event handlers for the application.

Returns:
  The event handlers for the application.

### isInitialized

boolean isInitialized()
Returns true if the RuntimeInstance has been successfully initialized.

Returns:
  True if the RuntimeInstance has been successfully initialized.

### createNewParser

Parser createNewParser()
Create a new parser instance.

Returns:
  A new parser instance.

### getDirective

Directive getDirective(String name)
Retrieve a previously instantiated directive.

Parameters:
  `name` - name of the directive
Returns:
  the directive with that name, if any
Since:
  1.6

### useStringInterning

boolean useStringInterning()
Check whether the engine uses string interning

Returns:
  true if string interning is active

### getSpaceGobbling

RuntimeConstants.SpaceGobbling getSpaceGobbling()
get space gobbling mode

Returns:
  space gobbling mode

### isHyphenAllowedInIdentifiers

boolean isHyphenAllowedInIdentifiers()
Get whether hyphens are allowed in identifiers

Returns:
  configured boolean flag
Since:
  2.1

### isScopeControlEnabled

boolean isScopeControlEnabled(String scopeName)
Get whether to provide a scope control object for this scope

Parameters:
  `scopeName` -
Returns:
  scope control enabled
Since:
  2.1

### getParserConfiguration

ParserConfiguration getParserConfiguration()
Get the replacement characters configured for this runtime service's parser

Returns:
  configured replacement characters
Since:
  2.2